/*-----------------------------------------------------------------------------
*
* Enhydra JdbcS
* The Initial Developer of the Original Code is Lutris Technologies Inc.
* Portions created by Lutris are Copyright 1997-2000 Lutris Technologies Inc.
* All Rights Reserved.
*
* The contents of this file are subject to the Enhydra Public License
* Version 1.1 (the "License"); you may not use this file except in compliance
* with the License. You may obtain a copy of the License at
* www.enhydra.org/license/epl.html
*
* Software distributed under the License is distributed on an "ASIS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
* the specific language governing rights and limitations under the License.
*
* -----------------------------------------------------------------------------
*/

package org.enhydra.jdbc.standard;

import org.enhydra.jdbc.util.LRUCache;

import java.sql.PreparedStatement;
import java.sql.SQLException;

/**
 * Implementation of LRUCache to handle prepared statements
 * TODO: Override put to check type
 */
public class PreparedStatementCache extends LRUCache {

	/**
	 * Constructor
	 */
	public PreparedStatementCache(int maxSize) {
		super(maxSize);
	}

	/**
	 * Overriden to close the statement
	 */
	protected void cleanupObject(Object obj) {
		log.debug(
			"PreparedStatementCache:cleanupObject class='"
				+ obj.getClass()
				+ "'");
		log.debug(
			"PreparedStatementCache:cleanupObject close a PreparedStatement o="
				+ "'"
				+ obj.toString()
				+ "'");
		try {
			((PreparedStatement) obj).close();
			//obj = null;
		} catch (SQLException e) {
			log.error(
				"PreparedStatementCache:cleanupObject problem to close"
					+ "a PreparedStatement: "
					+ e);
		}
	}

}
